VERSION 4.00
Begin VB.Form frmAppBar 
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   0  'None
   ClientHeight    =   3330
   ClientLeft      =   3510
   ClientTop       =   3105
   ClientWidth     =   5985
   ControlBox      =   0   'False
   Height          =   3735
   Left            =   3450
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3330
   ScaleWidth      =   5985
   ShowInTaskbar   =   0   'False
   Top             =   2760
   Width           =   6105
   Begin VB.Timer tmrHide 
      Interval        =   1
      Left            =   720
      Top             =   1440
   End
   Begin VB.PictureBox picFrame 
      BorderStyle     =   0  'None
      Height          =   495
      Left            =   1800
      ScaleHeight     =   495
      ScaleWidth      =   1215
      TabIndex        =   0
      Top             =   1320
      Width           =   1215
   End
End
Attribute VB_Name = "frmAppBar"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Dim BarData As APPBARDATA

Dim bAutoHide As Boolean    'Cacher automatiquement la barre
Dim bAnimate As Boolean     'Animation de la barre
Private Sub Form_Load()

'NOM : AppBar
'AUTEUR : Dino Cleaver
'       deanc@ nettech.co.nz
'       http://www.calamistrum.com/VisualDesign/vb-examples.html
'Traduit en franais par Antoine de Montgolfier
'                         vbasic@citeweb.net
'Code trouv sur Le petit monde de VIsual Basic
'                http://vbasic.citeweb.net
'
'Objectif : crer une barre semblable  la barre des tches
'de Windows 95, c'est  dire une barre qui "rserve" de la place
'sur l'cran, et qui peut se cacher quand la souris n'est plus dessus.


Dim lResult As Long

'Met la barre tout en haut de l'cran
Move 0, 0, 0, 0
Screen.MousePointer = vbDefault

'Valeurs par dfaut
bAutoHide = True
bAnimate = True

'Indique les paramtres de la barre
BarData.cbSize = Len(BarData)
BarData.hwnd = hwnd
BarData.uCallbackMessage = WM_MOUSEMOVE

lResult = SHAppBarMessage(ABM_NEW, BarData) 'Cre la barre
lResult = SetRect(BarData.rc, 0, 0, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN))

BarData.uEdge = ABE_TOP 'Position de la barre sur l'cran
lResult = SHAppBarMessage(ABM_QUERYPOS, BarData)    'Valide le tout pour crer la barre

If bAutoHide = True Then   'Si cacher automatiquement
    BarData.rc.Bottom = BarData.rc.Top + 2
    lResult = SHAppBarMessage(ABM_SETPOS, BarData)
    BarData.lParam = True
    lResult = SHAppBarMessage(ABM_SETAUTOHIDEBAR, BarData)
    
    If lResult = 0 Then
        bAutoHide = False
    Else
        lResult = SetWindowPos(BarData.hwnd, HWND_TOP, BarData.rc.Left, BarData.rc.Top - 42, BarData.rc.Right - BarData.rc.Left, 44, SWP_NOACTIVATE)
    End If
    
End If

If Not bAutoHide Then   'Si ne pas cacher automatiquement
    BarData.rc.Bottom = BarData.rc.Top + 42 'Largeur de la barre
    lResult = SHAppBarMessage(ABM_SETPOS, BarData)
    lResult = SetWindowPos(BarData.hwnd, HWND_TOP, BarData.rc.Left, BarData.rc.Top, BarData.rc.Right - BarData.rc.Left, 42, SWP_NOACTIVATE)
End If

End Sub


Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

Static bRecieved As Boolean
Dim lResult As Long
Dim newRC As RECT
Dim lMessage As Long

lMessage = X / Screen.TwipsPerPixelX

Beep

If bRecieved = False Then
    bRecieved = True
    Select Case lMessage
        Case WM_ACTIVATE
            lResult = SHAppBarMessage(ABM_ACTIVATE, BarData)
        Case WM_WINDOWPOSCHANGED
            lResult = SHAppBarMessage(ABM_WINDOWPOSCHANGED, BarData)
        Case ABN_STATECHANGE    'Par exemple, si la position de la barre des tches de Windows change
            lResult = SetRect(BarData.rc, 0, 0, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN))
            BarData.uEdge = ABE_TOP
            lResult = SHAppBarMessage(ABM_QUERYPOS, BarData)
            If bAutoHide Then
                BarData.rc.Bottom = BarData.rc.Top + 2
                lResult = SHAppBarMessage(ABM_SETPOS, BarData)
                BarData.lParam = True
                lResult = SHAppBarMessage(ABM_SETAUTOHIDEBAR, BarData)
                If lResult = 0 Then
                    bAutoHide = False
                Else
                    lResult = SetWindowPos(BarData.hwnd, HWND_TOP, BarData.rc.Left, BarData.rc.Top - 42, BarData.rc.Right - BarData.rc.Left, 44, SWP_NOACTIVATE)
                End If
            End If
            If Not bAutoHide Then
                BarData.rc.Bottom = BarData.rc.Top + 42
                lResult = SHAppBarMessage(ABM_SETPOS, BarData)
                lResult = SetWindowPos(BarData.hwnd, HWND_TOP, BarData.rc.Left, BarData.rc.Top, BarData.rc.Right - BarData.rc.Left, 42, SWP_NOACTIVATE)
            End If
        Case ABN_FULLSCREENAPP  'Si une application prend tout l'cran, y compris la place rserve  la barre des tches (ex : programmes d'installation)
            Beep
    End Select
    bRecieved = False
End If

End Sub

Private Sub Form_Resize()
    picFrame.Move 0, 0, Width, Height
End Sub

Private Sub Form_Unload(Cancel As Integer)

'Supprime la barre
If BarData.hwnd <> 0 Then SHAppBarMessage ABM_REMOVE, BarData

End Sub


Private Sub picFrame_DblClick()

Dim lResult As Long

'Double clic -> sortie du programme
Unload Me
'Dans Form_Unload, la barre sera supprime du systme

End Sub

Private Sub picFrame_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

'Sert quand on fait apparaitre la barre alors qu'elle tait cache
Dim lResult As Long
Dim iCounter As Integer

If Top < 0 Then     'Si la barre tait cache
    If bAnimate Then    'Si animation de la barre
        For iCounter = -36 To -1    'Dfilement progressif
            BarData.rc.Top = iCounter
            lResult = SetWindowPos(BarData.hwnd, 0&, BarData.rc.Left, BarData.rc.Top, BarData.rc.Right - BarData.rc.Left, 42, SWP_NOACTIVATE)
        Next
    End If
    
    BarData.rc.Top = 0  'Place le haut de la barre  l'origine de l'cran
    lResult = SetWindowPos(BarData.hwnd, HWND_TOPMOST, BarData.rc.Left, BarData.rc.Top, BarData.rc.Right - BarData.rc.Left, 42, SWP_SHOWWINDOW)
    tmrHide.Enabled = True  'Active le timer pour faire redescendre la barre ensuite
End If

End Sub


Private Sub tmrHide_Timer()

'Cache la barre si la souris n'est pas dessus

Dim lResult As Long
Dim lpPoint As POINTAPI
Dim iCounter As Integer

lResult = GetCursorPos(lpPoint) 'Cherche la position de la souris

'Si la souris est en dehors de la barre
If lpPoint.X < Left \ Screen.TwipsPerPixelX Or lpPoint.X > (Left + Width) \ Screen.TwipsPerPixelX Or lpPoint.Y < Top \ Screen.TwipsPerPixelY Or lpPoint.Y - 10 > (Top + Height) \ Screen.TwipsPerPixelY Then
    If bAnimate Then    'Si animation de la barre
        For iCounter = -1 To -37 Step -1    'Anime la disparition de la barre
            BarData.rc.Top = iCounter
            lResult = SetWindowPos(BarData.hwnd, 0&, BarData.rc.Left, BarData.rc.Top, BarData.rc.Right - BarData.rc.Left, 42, SWP_NOACTIVATE)
        Next
    End If
    BarData.rc.Top = -42    'Place la barre en position cache
    lResult = SetWindowPos(BarData.hwnd, HWND_TOPMOST, BarData.rc.Left, BarData.rc.Top, BarData.rc.Right - BarData.rc.Left, 44, SWP_NOACTIVATE)
    tmrHide.Enabled = False 'Arrte le timer
End If

End Sub


